#include<msp430g2553.h>
#include"spi.h"
#define U8 unsigned char
#define S8 signed char
#define U32 unsigned int
//U32 counter_1ms_int = 0;
//U32 counter_1ms_int_backup = 0;
//-------------------------------------------------------RF4432ָ------------------------------------------------------------
#define RR		0x00
#define WR		0x80
//********************************************************************************//
//* :					 delay_10us										  //
//* ܣ                 ʱ10us                                           //
//********************************************************************************//
void delay_10us(char n)
{
	int i;
	while(n--)
	for(i=0;i<5;i++);
}
void delay_ms(unsigned int ms)
{
	unsigned int i;
	unsigned char j;
	for(i=0;i<ms;i++)
	{
		for(j=0;j<200;j++);
		for(j=0;j<102;j++);
	} 
}
//********************************************************************************//
//* :					 	SPI_Init(void)						              //
//* ܣ                  SPIʼ                                     //
//********************************************************************************//
void SPI_Init(void)
{
	IO_SPI_DIR;
        RF4432_SEL_1;    
	RF4432_SCLK_0;
}
//********************************************************************************//
//* :					 	SPI_Read(void)						              //
//* ܣ                SPIֽڶȡ                                   //
//********************************************************************************//
unsigned char SPI_Read(void)
{

	unsigned char i,rxdata;
	rxdata = 0x00;
	for (i = 0;i < 8;i++)
	{
		rxdata = rxdata<<1;
		RF4432_SCLK_0;
		if (RF4432_SDO)	//ȡλĩβͨλֽ
		{
			rxdata |= 0x01;
		}
		delay_10us(2);	
		RF4432_SCLK_1;
		delay_10us(2);	
	 }
	 return rxdata;

}
//********************************************************************************//
//* :				SPI_Write(unsigned char txdata)					          //
//* ܣ                SPIֽд뺯                                   //
//********************************************************************************//
void SPI_Write(unsigned char txdata)
{
	unsigned char i;
	for (i = 0;i < 8;i++)
	{
		RF4432_SCLK_0;
		if ((txdata&0x80)==0x80)	//Ƿλ
		{
		    RF4432_SDI_1;
		}
		else
		{
	  	    RF4432_SDI_0;
		}
		txdata = txdata<<1;
		delay_10us(2);	
		RF4432_SCLK_1;
		delay_10us(2);	
	}
}
//********************************************************************************//
//* :				 	RF4432_ReadReg(unsigned char  addr)			          //
//* ܣ               RF4432Ĵȡ                                 //
//********************************************************************************//
unsigned char  SpiReadRegister(unsigned char  addr)
{
	unsigned char value;
	RF4432_SEL_0;                  
	SPI_Write(addr|RR);      
	value = SPI_Read();          
	RF4432_SEL_1;         
	return value;
}
//********************************************************************************//
//* :				 		  RF4432_WriteReg( )  			                  //
//* ܣ                   RF4432Ĵд뺯                             //
//********************************************************************************//
void  SpiWriteRegister(unsigned char  addr, unsigned char value)
{
	RF4432_SEL_0;                  
	SPI_Write(addr|WR);      
	SPI_Write(value);          
	RF4432_SEL_1;                 
}
/*void DelayMs(U32 ms)
{
    counter_1ms_int_backup = counter_1ms_int;
    while(counter_1ms_int - counter_1ms_int_backup <= ms);
}*/


/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  +
  + FUNCTION NAME: void SpiWriteRegister(U8 reg, U8 value)
  +
  + DESCRIPTION:   This function writes the registers 
  + 					
  + INPUT:			 U8 reg - register address   
  +					 U8 value - value write to register	
  +
  + RETURN:        None
  +
  + NOTES:         Write uses a Double buffered transfer
  +
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/*void SpiWriteRegister (U8 reg, U8 value)
{
	S8 i = 0;
	//Select the radio by pulling the nSEL pin to low
   	NSEL = 0;
	Delay(SPI_CLOCK_DELAY);
	//Transmit the data to radio.                            
	SDI = 1; //Send write flag;
    SCLK = 0;
	Delay(SPI_CLOCK_DELAY);
	SCLK = 1;
	Delay(SPI_CLOCK_DELAY);

	//Send out address;
	for(i = 6; i >= 0; i--)
	{
		SDI = (reg >> i) & 0x01;
		SCLK = 0;
		Delay(SPI_CLOCK_DELAY);
		SCLK = 1;
		Delay(SPI_CLOCK_DELAY);	
	}

	//Send out data;
	for(i = 7; i >= 0; i--)
	{
		SDI = (value >> i) & 0x01;
		SCLK = 0;
		Delay(SPI_CLOCK_DELAY);
		SCLK = 1;
		Delay(SPI_CLOCK_DELAY);	
	}

   	//Deselect the radio by pulling high the nSEL pin
	NSEL = 1;
	SCLK = 0;
	Delay(SPI_CLOCK_DELAY);

}
*/

/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  +
  + FUNCTION NAME: U8 SpiReadRegister(U8 reg)
  +
  + DESCRIPTION:   This function reads the registers 
  + 					
  + INPUT:		   U8 reg - register address   
  +
  + RETURN:        SPI1DAT - the register content 
  +
  + NOTES:         none
  +
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/*U8 SpiReadRegister (U8 reg)
{
	U8 value = 0;
    S8 i = 0;

	//Select the radio by pulling the nSEL pin to low
   	NSEL = 0;
	Delay(SPI_CLOCK_DELAY);

	//Transmit the data to radio.                            
	SDI = 0; //Send write flag;
    SCLK = 0;
	Delay(SPI_CLOCK_DELAY);
	SCLK = 1;
	Delay(SPI_CLOCK_DELAY);

	//Send out address;
	for(i = 6; i >= 0; i--)
	{
		SDI = (reg >> i) & 0x01;
		SCLK = 0;
		Delay(SPI_CLOCK_DELAY);
		SCLK = 1;
		Delay(SPI_CLOCK_DELAY);	
	}

	//Read data output;
	for(i = 7; i >= 0; i--)
	{
		SCLK = 0;
		Delay(SPI_CLOCK_DELAY);
		SCLK = 1;
		Delay(SPI_CLOCK_DELAY);
		value = value << 1;
		value |= SDO;
	}

   	//Deselect the radio by pulling high the nSEL pin
	NSEL = 1;                             
	SCLK = 0;
	Delay(SPI_CLOCK_DELAY);

   	return value;
}
*/

